<template>
  <v-app
    v-if="userLoaded"
    v-resize="onResize"
    :style="`background-color: ${$vuetify.theme.themes[theme].pageBackground}`"
  >
    <v-app-bar
      app
      :style="`background-color: ${$vuetify.theme.themes[theme].cardBackground}`"
    >
      <!-- Name and Logo -->
      <v-row
        style="cursor: pointer;"
        align="center"
        @click="goPhasing()"
      >
        <img
          src="@/../public/img/png/jlc-badge.png"
          alt="JLC Logo"
          style="width:48px;height:48px;"
          class="mx-3"
        >
        <span
          class="title mr-5"
        >SCB Materiel Maintenance Financials</span>

        <!-- Search -->

        <v-spacer />
        <span
          class="title pr-5"
        >Welcome {{ $store.state.app.user.name }}</span>

        <!-- User settings menu -->
        <v-menu
          :loading="loading.preferences"
          :close-on-content-click="closeOnContentClick"
          offset-y
        >
          <v-progress-linear :indeterminate="loading.preferences" />
          <template #activator="{ on, attrs }">
            <div class="pr-0 pt-0">
              <v-btn
                icon
                v-bind="attrs"
                v-on="on"
              >
                <v-icon>
                  mdi-menu
                </v-icon>
              </v-btn>
            </div>
          </template>
          <v-list
            width="250"
            flat
          >
            <v-list-item>
              <v-list-item-subtitle v-text="'MM APP PREFERENCES'" />
            </v-list-item>
            <v-list-item>
              <v-list-item-content>
                Dark Mode
              </v-list-item-content>
              <v-list-item-action>
                <v-checkbox
                  v-model="darkMode"
                  class="my-0"
                  hide-details
                  :disabled="loading.preferences"
                />
              </v-list-item-action>
            </v-list-item>
            <!-- <v-list-item>
              <v-list-item-content>
                Dense Table Rows
              </v-list-item-content>
              <v-list-item-action>
                <v-checkbox
                  v-model="denseTableRows"
                  class="my-0"
                  hide-details
                  :disabled="loading.preferences"
                />
              </v-list-item-action>
            </v-list-item> -->

            <v-divider class="my-2" />

            <v-list-item>
              <v-list-item-subtitle v-text="'Phasing Data'" />
            </v-list-item>
            <v-list-item-group>
              <v-list-item @click="goPhasing()">
                MM Phasing Bids
              </v-list-item>
            </v-list-item-group>

            <div v-if="$store.state.app.user.isAdmin">
              <v-divider class="my-2" />

              <v-list-item>
                <v-list-item-subtitle v-text="'Bid Manager'" />
              </v-list-item>
              <v-list-item-group>
                <v-list-item
                  @click="openJLUs()"
                >
                  Edit JLU Data
                </v-list-item>
                <!-- <v-list-item
                  @click="openDSAs()"
                >
                  Edit DSA Data
                </v-list-item> -->

                <v-list-item
                  v-if="$store.state.app.user.isAdmin"
                  @click="openUsers()"
                >
                  Edit User Data
                </v-list-item>
                <v-list-item
                  @click="openAbout()"
                >
                  About Page
                </v-list-item>
              </v-list-item-group>
            </div>
          </v-list>
        </v-menu>
      </v-row>
    </v-app-bar>

    <v-main>
      <router-view />
    </v-main>
  </v-app>
</template>

<script>
import { patch } from 'kyd-utils';

export default {
  name: 'App',
  components: {
  },
  data: () => ({
    usr: true,
    windowSize: {
      x: 0,
      y: 0,
    },
    // customCategories: [],
    // searchString: '',
    // feedbackDialogProps: {
    //   item: {},
    //   title: 'Give Feedback',
    //   actionButtons: [
    //     { text: 'Cancel', emitRef: 'event' },
    //     { text: 'Submit', emitRef: 'submitFeedback', color: 'primary' },
    //   ],
    // },
    // resetFavourite: false,
    // searchString: '',
    closeOnContentClick: true,
    loading: {
      app: false,
      preferences: false,
    },
    appKey: '',
    navItems: [
      { title: 'All', icon: 'mdi-database' },
      { title: 'Favourites', icon: 'mdi-heart-outline' },
      { title: 'Apps', icon: 'mdi-apps' },
    ],
  }),
  computed: {
    user() {
      return this.$store.state.app.user;
    },
    userLoaded() {
      return !!this.$store.state.app.user.id;
    },
    darkMode: {
      get() {
        return this.$vuetify.theme.isDark;
      },
      set(bool) {
        this.$vuetify.theme.isDark = bool;
        this.updatePreference({ darkMode: bool });
      },
    },

    denseTableRows: {
      get() {
        return this.$store.state.app.user.denseRows;
      },
      set(bool) {
        this.updatePreference({ denseRows: bool });
      },
    },

    theme() {
      return (this.$vuetify.theme.isDark) ? 'dark' : 'light';
    },
  },
  mounted() {
    // this.goHome(); plus change the link from Page Heading in HTML
    this.goPhasing();
  },
  methods: {
    updatePreference(payload) {
      this.loading.preferences = true;
      const params = { params: { filter: [{ and: [{ key: 'id', equals: this.$store.state.app.user.id }] }] } };
      patch(
        '/settings',
        payload,
        params,
      ).then(() => {
        this.loading.preferences = false;
      });
    },
    // retMain() {
    //   if (this.$route.name !== 'jluData') this.$router.push({ name: 'jluData' });
    // },
    openJLUs() {
      if (this.$route.name !== 'jluData') this.$router.push({ name: 'jluData' });
    },
    openDSAs() {
      if (this.$route.name !== 'dsaData') this.$router.push({ name: 'dsaData' });
    },
    openFYs() {
      if (this.$route.name !== 'fyData') this.$router.push({ name: 'fyData' });
    },
    openAbout() {
      if (this.$route.name !== 'About') this.$router.push({ name: 'About' });
    },
    openUsers() {
      if (this.$route.name !== 'userData') this.$router.push({ name: 'userData' });
    },
    goPhasing() {
      this.$router.push({ name: 'PhasingSummary' }).catch(() => { console.log('navigation did not change'); });
    },
    goHome() {
      this.$router.push({ name: 'Home' }).catch(() => { console.log('navigation did not change'); });
    },
    openFeedbackDialog() {
    },
    resetFav() {

    },
    onResize() {
      // eslint-disable-next-line
      const payload = { x: self.innerWidth, y: self.innerHeight };
      // eslint-disable-next-line
      this.windowSize = { x: self.innerWidth, y: self.innerHeight };
      // console.log('on resize', payload)
      this.$store.dispatch('app/setViewPort', payload);
    },
  },
};
</script>
